#!/usr/bin/perl
#
#	sun_iostat_summary.pl
#
#	This program will execute an iostat command and collect the info, total and average it
#	and finally pass it to the caller via a single line of output to stdout.
#

$icount = 2;
open( IOS, "iostat -x 4 $icount |" ) || die("Cannot do iostat command");

$hcount = 0;
$dcount = 0;
# Line items
$rs   = 0;
$ws   = 0;
$krs  = 0;
$kws  = 0;
$w8   = 0;
$actv = 0;
$svct = 0;
$pw   = 0;
$pb   = 0;
# Accumulators for Line items
$ars   = 0;
$aws   = 0;
$akrs  = 0;
$akws  = 0;
$aw8   = 0;
$aactv = 0;
$asvct = 0;
$apw   = 0;
$apb   = 0;

while (<IOS>)
{
	chomp;
	if ( $hcount == $icount )
	{
		if ( m/^(s{1,2}d\d+)\s+(.*)/ )
		{
			#got a s[s]dnnn device
			$dcount++;
			#print "$dcount \t=$1:\t:$2:\n";
			#print "$_\n";
			( $rs, $ws, $krs, $kws, $w8, $actv, $svct, $pw, $pb ) = split(/\s+/,$2);
			$ars   = $ars   + $rs;
			$aws   = $aws   + $ws;
			$akrs  = $akrs  + $krs;
			$akws  = $akws  + $kws;
			$aw8   = $aw8   + $w8;
			$aactv = $aactv + $actv;
			$asvct = $asvct + $svct;
			$apw   = $apw   + $pw;
			$apb   = $apb   + $pb;
			next;
		}
	}
	if ( m/^device\s+.*/ )
	{
		#print "$_\n";
		$hcount++;
		next;
	}
}
print "$dcount $ars $aws $akrs $akws $aw8 $aactv $asvct $apw $apb";
exit 0;
